
define(['jquery', './select'], function($){

	$.widget('ui.parameterTime', $.ui.parameterSelect, {

		_name: 'base_time',

		_make_html: function() {
			var self = this, o = self.options, p = o.parameter;
			self.element.empty();
			self.element.removeAttr('id'); // TODO id of time-navigator clashes with the TimeNagivator widget

			if(!p.availability) return;

			// the step and base_time of these Times will be ignored.
			p.labels = [];
			p.values = [];

			var value = -1;
			$.each(p.availability, function(i, v) {
				var str = v.base_time.format(p.format || 'ddd dd mmm yyyy HH "UTC"');
				if(!~$.inArray(str, p.labels)){
					p.values.unshift(i);
					p.labels.unshift(str);
					if(p.value.base_time.value === v.base_time.value) value = i;
				}
			});
			if(value < 0) console.error('value not found');

			if(p.values.length > 1){
				self.menu = self.element.div()[o.prefer_select ? 'chartParameterMenu' : 'wwwChartParameter']({
					name: self._name,
					title: 'Base time',
					value: value,
					values: p.values,
					labels: p.labels,
					menu_items: self.bind(self._make_menu_items),
					select: self.bind(self.select_by_value),
					on_click: function(event, ui, parameter) {
						var val = ui.item.value || ui.item.attr('data-value');
						if(p.availability[val]){
							var time = new Time(p.availability[val].base_time, p.value.step, p.value.valid_time);
							o.on_select(p.find_time_by_base_time(time));
						}
					}
				});
			}
			this._on_content_update();
		},

		select_by_value: function() {
			var self = this, o = self.options, p = o.parameter;

			if(self.menu){
				if(!self.menu.find('ul').length){
					return console.log('bt.select_by_value: cannot select: menu items not yet created');
				}

				var a = $.map(p.availability, function(v, i){
					if(v.base_time.getTime() === p.value.base_time.getTime()) return "[data-value='" + i + "']";
				});

				self.menu.wwwChartParameter('select', self.menu.find(a.join(',')));
			}
		},

		_on_parameter_change: function() {
			var self = this, o = self.options, p = o.parameter;

			if(p.availability_changed){
				self._make_html();
			}

			if(self.menu){
				// dont forget that the menu is not created until it is opened.
				if(!self.menu.find('ul').length){ console.log('bt._on_parameter_change: cannot select: menu items not yet created'); return; }

				if(!self.menu.find("[data-value='" + p.index() + "']").length) console.warn('controls.base_time.on_parameter_change: index not found in menu: ', p.index(), ': ', p.availability[p.index()].base_time.format('mmdd:hh'), p.availability[p.index()].step, p.availability[p.index()].valid_time.format('mmdd:hh'));
				console.log('   bt._on_parameter_change: index=', p.index(), ' value=', [p.value.base_time.format('mmdd:HH'), p.value.step, p.value.valid_time.format('mmdd:HH')], self.menu.find("[data-value='" + p.index() + "'] a").text());

				self.menu.wwwChartParameter('select', self.menu.find("[data-value='" + p.index() + "']"));
			}
		},

		_make_menu_items: function() {
			var o = this.options, p = o.parameter;
			return this.menu_items = $.map(p.values, function(a, i){ return '<li data-value="' + a + '"><a href="#" >' + (p.labels[i] || a) + '</a>' + (i ? '' : '<span class="ui-icon ui-icon-check"/>') + '</li>'});
		}
	});
});
