
define(['jquery', './control', './widgets/menu', './widgets/menu2'], function($){

	$.widget('ui.parameterSelect', $.ui.parameterControl, {

		_make_html: function() {
			var self = this, o = self.options;
			self.element.empty();

			self.element.div()[o.prefer_select ? 'chartParameterMenu' : 'wwwChartParameter']($.extend({
				menu_items: self.bind(self._make_menu_items),
				on_click: function(event, ui, parameter) {
					var value = ui.item.value || ui.item.attr('data-value');
					console.log('parameterSelect.on_click:', value);
					o.on_select(value);
				}
			}, o.parameter));
		},

		_on_content_update: function(changed) {
			if(changed && changed.get('parameters')){
				this.setItems(this.options.parameter);
			}
			var val = this.options.parameter.value;
			this.element.find('span.ui-icon-check').appendTo(this.element.find('[data-value="' + val + '"]'));
		},

		_make_menu_items: function() {
			var p = this.options.parameter;
			return $.map(p.values, function(a, i){ return '<li data-value="' + a + '"><a href="#" >' + (p.labels && p.labels[i] || a) + '</a>' + (i ? '' : '<span class="ui-icon ui-icon-check"/>') + '</li>'})
		}
	});
});
