/*
 *  A button with a drop down menu.
 */
define(['jquery', 'bus', 'jquery_ui/widget'], function($, Bus){

	$.widget('ui.wwwChartParameter', {
		options: {
			name: 'missing',
			title: 'Untitled',
			value: null,
			values: [],
			labels: null,
			bus: Bus(),
			select: null,           // function to mark the correct menu item dom element as selected. Is a temporary workaround for base_time parameter being in unusual format.
			on_click: $.noop
		},

		_create: function(){
			var self = this, o = self.options;
			self.selected_value = o.value || null;

			o.labels || (o.labels = o.values);

			(self.button = self.element.addClass('parameter-selector').button({label: o.title.replace(/_/g, ' '), icons: {secondary: 'ui-icon-triangle-1-s'}}))
				.click(function(){
					self.element.parent().parent().find('.ui-menu').not(self.menu ? self.menu : null).hide();

					if(o.values.length){

						self.menu = self.menu_items
							? self.menu.toggle()
							: $('<ul id="' + o.name + '-menu" class="parameter-menu">' + (self.menu_items || (self.menu_items = o.menu_items())).join('') + '</ul>')
								.appendTo(self.button)
								.menu({
									select: function(event, ui){
										console.log('menu.selection: ', ui.item.text(), ui.item.attr('data-value'));
										o.on_click(event, ui, o.name);
										self.select(ui.item);

										setTimeout(function(){
											self.menu.menu('instance').mouseHandled = false; // jquery ui menu workaround
										}, 5);
									}
								})
								.each(function(){
									self.select_by_value();
								});
					}else{
						o.on_click(o.name);
					}

					return false;
				});

				o.bus.listen('chart-content-update', function(_, msg) {
					var instance = msg.product;
					if(self.selected_value !== instance.variables[o.name].value){
						self.selected_value = instance.variables[o.name].value;
						self.select($(this).find("[data-value='" + self.selected_value + "']"));
					}
				});
		},

		_destroy: function(){
			this.element.removeClass('parameter-selector');
		},

		setItems: function(parameter){
			var o = this.options;
			o.values = parameter.values;
			o.labels = parameter.labels || [];
			this.menu_items = null;
			this.menu && this.menu.remove();
		},

		select_by_value: function() {
			var self = this, o = this.options;

			if(o.select){
				o.select();
				return;
			}
			self.selected_value && self.select(this.element.find("[data-value='" +  self.selected_value + "']").orelse(function(){ console.log('wwwChartParameter: value not found: ', self.selected_value); }));
		},

		select: function(el){
			el.parent().find('span').remove();
			el.span({'class': 'ui-icon ui-icon-check'});
		}
	});
});
