/*
 *  basic_chart/parameter_menu
 *
 *  This chart mixin creates a menu bar for parameter selection.
 *
 */
define(['jquery', 'bus', './parameter_controls/factory', './parameter_menu.css'], function($, Bus) {

	return function(chart, o){

		typeof o.controls === 'string' && (o.controls = $(o.controls));
		o.controls.addClass('www-chart-parameter-bar');

		chart.bus.listen('product-swapped', function() {
			o.controls.find('> *').not('.keep').remove();
		});

		chart.bus.listen('product-swapped-and-loaded', function(msg) {

			if(o.controls.find('> div').not('.keep').length) return console.warn('cannot create parameter menu, container not empty');

			if($.isEmptyObject((chart.instance || chart.product).variables)){
				o.controls.p().text('No modifiable parameters');
			}else{
				$.each(chart.instance.variables, function(i, param) {
					o.controls.div({id: param.name + '-navigator'})
						.basicControlFactory({
							parameter: param,
							instance: (chart.instance || chart.product),
							bus: chart.bus,
							on_select: function(val){
								console.log('catalogue2.basic.control.on_select: ', val);
								Bus().send('add-page-state');
							}
						});

					typeof param === 'choice' && console.warn('parameter_menu: parameter-type choice not handled');
				});
			}
			o.controls.show();
		});

		$('body').unbind('click', close).click(close);

		this.destroy = function() {
											chart.bus.forget(this); // not needed. chart is destroyed so should not emit messages.
			o.controls.find('> .parameter-control').remove();
		}

		function close() {
			o.controls.find('.parameter-menu').hide();
		}
	}
});
