/*
 *  Show a menu bar with drop down menus for each chart parameter.
 *
 *  TODO this is essentially a duplication of widgets/www_chart/parameter_menu.js
 *       Differences to resolve: slightly different signals, bus property has different name.
 */
define(['jquery', 'chart', 'basic_chart/parameter_controls/factory', 'basic_chart/parameter_menu.css'], function($) {

	return function(chart, o){
		var controls = chart.element.parent()
			.find('.chart-controls')
			.orelse(function(){
				return chart.element.div('.chart-controls').insertBefore(chart.element);
			});

		chart.options.messageBus.listen('chart-content-update', function() {
			controls.show().find('.parameter-control').remove();

			if($.isEmptyObject(chart.product.variables)){
				controls.find('.no-params').orelse(function(){ controls.p('.no-params').text('No modifiable parameters'); });
			}else{
				$.each(chart.product.variables, function(i, param) {
					controls.div({id: param.name + '-navigator'})
						.basicControlFactory({
							parameter: param,
							instance: chart.product,
							bus: chart.options.messageBus,
							on_select: function(val){
								console.log('parameter_menu.control.on_select: ', val);

								chart.options.messageBus.send('new-history-state');
							}
						});
				});
			}
		});

		this.destroy = function() {
			controls.find('.parameter-control:not(.keep)').remove();
		}
	};
});
