/*
 *  Note: widget cannot be used in MSIE if the element contains transparent pngs.
 */
define(['jquery'], function($) {


   // width() and height() return zero if the element is not attached to the DOM
   // or if one on the parent is hidden....

   function realize(elem, cb) {
       var hidden = elem.parents().filter(function(i, e) {
           return $(e).css('display') === 'none';
       });

       var save = [];

       var attached = elem.parents('body').size() != 0;
       var root;

       if (!attached) {
           root = $(elem.parents().get(-1) || elem);
           root.appendTo($('body'));
       }

       hidden.css('opacity', function(i, old) {
           save.push(old);
           return 0;
       }).show();

       var result = cb(elem);

       hidden.hide().css('opacity', function(i, old) {
           return save.pop();
       });

       if (!attached) {
           root.detach();
       }

       return result;
   }


   $.fn.hiddenWidth = function(options) {
       return this.width() ||
       realize(this, function(e) {
           return e.width();
       });
   };

   $.fn.hiddenHeight = function(options) {
       return this.height() ||
       realize(this, function(e) {
           return e.height();
       });
   };

   $.fn.hiddenInnerWidth = function(options) {
       return this.innerWidth() ||
       realize(this, function(e) {
           return e.innerWidth();
       });
   };

   $.fn.hiddenInnerHeight = function(options) {
       return this.innerHeight() ||
       realize(this, function(e) {
           return e.innerHeight();
       });
   };

   $.fn.hiddenOuterWidth = function(options) {
       return this.outerWidth(options) ||
       realize(this, function(e) {
           return e.outerWidth(options);
       });
   };

   $.fn.hiddenOuterHeight = function(options) {
       return this.outerHeight(options) ||
       realize(this, function(e) {
           return e.outerHeight(options);
       });
   };

   $.fn.dimensions = function(options) {
       return realize(this, function(e) {
               return {
                width: e.width(),
                height: e.height(),
                innerWidth: e.innerWidth(),
                innerHeight: e.innerHeight(),
                outerWidth: e.outerWidth(),
                outerHeight: e.outerHeight(),
                outerWidthWithMargins: e.outerWidth(true),
                outerHeightWithMargins: e.outerHeight(true)
                };
       });
   };
});
