// TODO copy enable_experimental from htdocs/sites/all/modules/ecmwf/ecmwf_chart/js/dashboard.js for product-selector-dialogue and layout menu.

define(['config', 'jquery', 'user_info', 'application', 'dashboard/model', 'bus', 'dashboard/widgets/widget', 'jquery_ui/widget', 'messages', 'utils', 'ajax-indicator', 'dashboard', 'shortcuts'], function(ECMWF, $, User, Application, Tabs, Bus, DashboardWidget) {

new Application(function(){

	var wrapper, bus = Bus();

	$('#ajax-loader').ajaxIndicator();

	$('#messages').messages();

	Application.dashboard_ready = $.Deferred(function(df){
		setTimeout(function() {
			df.resolve();
		}, 10000);
		bus.listen_once('dashboard-set-loaded', function(_, set){
			df.resolve();
		});
	});

	Application.dashboard_ready.then(function(){
		$('#main > .loader').fadeOut(function(){
			$('#main').loader('destroy');
		});
		make_menus();
	});

	User.info.then(function() {
		Tabs.load(function(dashboard_set){

			wrapper = $('#main')
				.div('#dashboard-set')
					.dashboardSet({dashboard_set: dashboard_set, focused: ECMWF.request.widget, wrapper: '#main'});
					//.selectable({filter: 'li', cancel: '.widget-content', stop: function(e, ui){}});

			update_layout_menu();

			bus
				.listen('dashboard-set-changed', function(_, set){
					Tabs.save_dashboard_set(set, function(){
						console.log('set saved.');
					});
					update_layout_menu();
				})
				.listen('dashboard-changed', function(_, dashboard){
					Tabs.save_dashboard(dashboard.get_state(), function(){
						console.log('tab saved.');
					});
				})
				.listen('dashboard-animation-toggle', function(){
					//$.animationAdd();
				});

			$(document)
				.shortcuts({shortcuts: [
					{
						key    : $.ui.keyCode.SPACE,
						signal : 'dashboard-animation-toggle'
					},
					{
						key    : 70, // 'f'
						signal : 'fullscreen'
					}
				]});

			require(['forecaster/reporter'], function(Reporter) { Reporter(); });
		});
	});

	function update_layout_menu(){
		if(wrapper){
			$('#menu-panes .layout input').prop('checked', false);

			$('#menu-panes .layout .menu-list li:eq(' + (wrapper.dashboardSet('n_columns') - 1) + ') input')
				.prop('checked', true);
		}
		else console.warn('cannot update menu');
	}

	function make_menus(){

		if($('#menu-bar .menu-item').length) return;

		var layout_items = [];
		for(var i=1;i<=6;i++){
			layout_items.push({'class': 'menu-radio', name: 'radio-' + i, title: i +' Column' + (i - 1 ? 's' : '')});
		}

		var add_widget_items = $.map(DashboardWidget.registry(), function(widget){
			if(!widget.is_private){
				return {name: widget.kind, title: widget.title, selected: function(){
					wrapper.dashboardSet('add_widget', {widget: widget, top: true}, function(){
						$.logMessage('New widget added');
					});
				}};
			}
		});

		var enable_menubar = false;
		var menu = enable_menubar && new ECMWF.MenuBar('ul#menu-bar', 'menu-panes')
			.add([
				{
					name: 'addwidget',
					title: 'Add widget',
					items: add_widget_items
				},
				{
					name: 'layout',
					title: 'Layout',
					items: layout_items
				},
				{
					name: 'help',
					title: 'Help',
					items: [
						{name: 'help',              title: 'EcCharts help ...',   selected: function(){ window.open(ECMWF.options.settings.eccharts_help); }},
						{'class': 'menu-separator', title: '-'                    },
						{name: 'preferences',       title: 'Preferences ...',     selected: function(){ $(window).preferences(); }},
						{'class': 'menu-separator', title: '-'                    },
						{name: 'report',            title: 'Report issue ...'     }
					]
            /*
				},
				{
					name: 'go',
					title: 'Go',
					items: [
						{name: 'forecaster', title: 'Forecaster', selected: function(){ location.href = ECMWF.options.ajax.forecaster.forecaster; }},
						{name: 'dashboard',  title: 'Dashboard', disabled: true}
					]
            */
				}
			]);

		//$('ul#menu-bar').workspaceMenu({menu: menu, position: 2})

		bus
			.listen('menu-layout-radio-change', function(_, set){
				wrapper.dashboardSet('reflow', set.value.substring(13, 14));
			})

		enable_menubar && menu.bar.clear();
	}
});

});
