define(['jquery', './widget', 'bus', './controls.css'], function($, DashboardWidget, Bus) {

$.widget('ui.controlsDashboardWidget', $.ui.dashboardWidget, DashboardWidget.register('controlsDashboardWidget', {

	factory : {
		kind  : 'controls',
		title : 'Controls',
		data  : {}
	},

	options: {
		editable: false,
		messageBus: Bus()
	},

	_init: function() {
		var self = this, o = this.options;

		var bus = o.messageBus;

		$.ui.dashboardWidget.prototype._init.call(this);

		self.element.addClass('controlsDashboardWidget');

		self._height = 32;

		self.content.div('.tools')
			.thumbnailTools({selector: '.tools', always_on: true})
			.thumbnailTools('add', [
				['ui-icon-play',               function(){ bus.send('tool-animation-start'); }, 'Animate all charts'],
				['ui-icon-pause',              function(){ bus.send('tool-animation-pause'); }, 'Pause all animation'],
				['ui-icon-stop',               function(){ bus.send('tool-animation-stop');  }, 'Stop all animations'],
				['ui-icon-carat-1-w',          function(){ bus.send('prev-step');            }, 'Advance all charts to their previous time step'],
				['ui-icon-carat-1-e',          function(){ bus.send('next-step');            }, 'Advance all charts to their next time step'],
				['ui-icon-seek-prev',          function(){ bus.send('prev-day');             }, 'Step all products back by 24 hours'],
				['ui-icon-seek-next',          function(){ bus.send('next-day');             }, 'Advance all products by 24 hours'],
				['ui-icon-arrowthickstop-1-w', function(){ bus.send('first-step');           }, 'Set all charts to their first time step'],
				['ui-icon-arrowthickstop-1-e', function(){ bus.send('last-step');            }, 'Set all charts to their last time step'],
				['ui-icon-arrowthick-1-s',     function(){ bus.send('prev-base-time');       }, 'Advance all products to their previous base time'],
				['ui-icon-arrowthick-1-n',     function(){ bus.send('next-base-time');       }, 'Advance all products to their next base time'],
				['ui-icon-arrowthickstop-1-n', function(){ bus.send('bring-up-to-date');     }, 'Bring all products up-to-date']
			])
	},

	destroy: function() {
		this.element.removeClass('controlsDashboardWidget');
	},

	widget_height: function () {
		var self = this;

		var border_height = 2;
		var header_height = 24;

		return self._height + border_height + header_height;
	}

}));


});
