
define(['jquery', 'bus', './widget'], function($, Bus, DashboardWidget) {

$.widget('ui.textDashboardWidget', $.ui.dashboardWidget, DashboardWidget.register('textDashboardWidget', {

	factory : {
		kind  : "text",
		title : "New text widget",
		data  : { text : [
			"You can type any information here, using the [markdown][1] language.",
			"[1]: http://en.wikipedia.org/wiki/Markdown"
			].join("\n")
		}
	},

	options: {
		messageBus: Bus()
	},

	_init: function() {
		var self = this, o = this.options;

		$.ui.dashboardWidget.prototype._init.call(this);
		self.element.addClass('textDashboardWidget');
		self.markup = self.content.div()
			.markup(o.data.text)
			.each(function(){ o.data.text || $(this).addClass('empty'); });

		self._update_height(); //no. trigger height-changed instead?
	},

	/*
	destroy: function() {
		this.element.removeClass('textDashboardWidget');
	},
	*/

	/*
	_get_form: function() {
		var self = this, o = this.options;

		return [
			{ type: 'text', title: 'Text', name: 'text', value: 'FIXME'},
		];
	},
	*/

	edit: function(enable, form) {
		var self = this, o = this.options;
		console.log('text.edit');

		if(enable !== false){
			var size = {width: self.markup.width() -6, height: Math.max(40, self.markup.height() + 10)};
			self.markup.hide();
			self.textarea = (self.textarea || self.element.textArea(o.data.text)).css(size).show().focus();
		}else{
			o.data.text = self.textarea.val();
			self.textarea.hide();
			if(o.data.text) self.markup.removeClass('empty');
			self.markup.markup(o.data.text).show();
		}

		$.ui.dashboardWidget.prototype.edit.call(this, enable, form);
	},

	set_state: function(state) {
		var self = this, o = this.options;
		self.markup.markup(o.data.text);
		return null;
	}

}));
});

