define(['config', 'jquery', 'focusable'], function(ECMWF, $) {

return function ObjectListHandler() {

	this.options = {
		merge_user_catalogue: true
	}

	this.render = function (item) {
		var self = this;
		var div = $('<div>').a('Select ' + item._item.subtype + ' ...')
			.addClass('select-link')
			.prop('href', '#select')
			.attr('name', item.value)
			.focusable() //TODO tabindex not consecutive with other form elements.
			.click(function(){
				if(true){
					var el = $(this);
					$('body > .' + item._item.subtype + '-dialogue').each(function(){
						$(this).find('.filterable-thumbnail-list').dialog('open');
					}).orelse(function(){
						el.thumbnailDialogue({
							text: 'Please select one of these ' + item._item.title + 's',
							kind: item._item.subtype,
							merge_user_catalogue: self.options.merge_user_catalogue,
							actions: [{
								name: 'Select',
								on_click: function(selection){
									$('.filterable-thumbnail-list').dialog('close');
									div.attr({name: selection});
									if(self.on_update) self.on_update(item, selection);
								}}
							],
							hide_user_items: false,
							modal: true
						});
					});
				}else{
					/*
					 *  Newer selector dialogue currently only supporting catalogue products
					 */
					require(['vgrid', 'grid/products', 'grid/filterable_list', 'grid/filters/text', 'dialogue2013', 'virtual-dom/h', 'virtual-dom/diff', 'virtual-dom/patch'], function(VGrid, products, list, text_filter, Dialogue, h, diff, patch) {
						new Dialogue({
							id: 'product-select',
							title: '<h2>Product select</h2>',
							html: '<p>Please select a product</p><div></div>'
						});
						var el = $('#product-select');
						$('#product-select').css({width: 600}).modal('show').click(function() {
							console.log('ObjectListHandler: closing...');
							$('#product-select').modal('hide');
						});

						var grid = new VGrid({element: $('#product-select')})
						self.vdom = {
							root: $('#product-select .modal-body div')[0],
							tree: h('div')
						}
						var render = $.throttle(250, function() {
							var new_tree = grid.render()
							self.vdom.root = patch(self.vdom.root, diff(self.vdom.tree, new_tree));
							self.vdom.tree = new_tree;
						})

						var filters = [text_filter/*, facet_filter*/];
						$.map(filters, function(f) {
							if($.isFunction(f.fn)){
								f.init && f.init();
								list.filters.push(f);
							}
						})

						// TODO this duplicates fn in grid.js - should be done in the list, not in the grid
						$.map(list.filters, function(f){
							$.isFunction(f.fn) && f.events && f.events.bind('changed', function() {
								list.filter();
								render();
							});
						});

						products.set_package('catalogue');
						list.set_collection(products);
						list.on.items.subscribe(self, function() {
							list.filter(); // TODO should be done inside the list
						});

						$('#product-select').on('render', function() {
							render();
						});
					});
				}
				return false;
			});
		return div;
	};

	this.collect = function (item, widget) {
		return widget.attr('name');
	};
}

});
