/*
 * Dialogue box containing user editable preferences.
 *
 */

define(['config', 'jquery', 'chart/utils', 'bus', 'jquery_ui/widget'], function(ECMWF, $, Utils, Bus) {

$.widget('ui.preferences', {

	options: {
		messageBus : Bus()
	},

	_init: function() {

		var o = this.options;

		var items = [];
		$.eachUserPreference(function(item){
			if(item.editable !== false) items.push(item);
		});

		ECMWF.dialogue({
			width: 480,
			title: 'Preferences',
			items: items,
			ok: function(form) {
				o.messageBus.send('preferences-changed', form);
			}
		}).parent()
			.attr('id', 'preferences')
			/*
			.find('tr')
				.hover(function(){
					$(this).find('td:eq(2)').button({icons: {primary: 'ui-icon-help' }});
				}, function(){
					$(this).find('td:eq(2)').button('destroy');
				});
			*/
	},

	destroy: function(){
		console.log('destroy');
	}
});

});

