define(
		['config', 'jquery', 'bus', 'chart_app/chart_application', 'grid/products', 'product_browser/packages', 'grid/filters/text', 'grid/filters/facet', /*'grid/package_filter', */'grid/filters/path', '../chart_handler', 'chart_app/router', 'mixins', 'page/query', 'filterable-list', 'storage', 'element', 'vgrid', 'virtual-dom/h', 'virtual-dom/diff', 'virtual-dom/patch', 'vdom-virtualize', 'grid', 'facets', 'jquery_ui/button', 'throttle-debounce', 'messages', 'perfect-scrollbar', './view.css', '../product_browser.css'],
		function(ECMWF, $, Bus, ChartApplication, products, packages, text_filter, facet_filter, /*package_filter, */path_filter, CH, page, mixins, qs, list, localStorage, DOM, VGrid, h, diff, patch, virtualise) {

	var overlay = false; // config determining whether thumbnails are an overlay or main landing page content.
	var config = {
		show_view_buttons: false
	}

	var chart_handlers = CH;
	var page_handlers = {}; // these handlers manage chart-type differences that are outside the scope of chart widget plugins.

	var App = function(){};
	App.prototype = ChartApplication;

	var n_filter_runs = 0;

	// copied from grid - TODO move dupe
	var P = function(elem, grid) {
		return new GridPrivate(elem, grid);
	};
	var GridPrivate = function(elem, grid) {
		this.elem = this.$ = $(elem);
		this.grid = grid;
	};
	GridPrivate.prototype = {
		filter_input: function(filter) {
			var input, self = this;
			return input = this.elem
				.find('.thumbnail-list-filter').orelse(function(){ return self.elem.div(); })
					.inputFilter({label: '', on_filter: function(text){
						filter.enable().on_change(null, text);
					}});
		}
	}

	return $.extend(true, new App(), {
		config: {
			col2: {
				panel: {
					closeable: overlay, title: 'Results'
				}
			},
			enable_hierarchy: false,
			enable_text: true, // remove ?
			use_column_width: true
		},

		col1: function(o) {
			var w = this.widgets;
			var self = this;

			// set this to have the product list sorted (can be used for grouping)
			//list.sort_by = 'title';

			App.prototype.col1.apply(this, arguments);

			this.have_url.done(function() {
				path_filter.set([page.params.product_path]);
				self.update_category_links();
			});

			overlay && o.el.div('.show-results submit').text('Show product results').button().click(function() {
				self.widgets.col2.panel('show');
			});

			this.config.enable_hierarchy && (
				$.extend(self.widgets, {
					category_h2: o.el.h2('Categories'),
					path_links: o.el.ul('.path-links').text('Path links')
				}),

				path_filter.events.bind('changed', function(path){
					console.log('-> path_filter changed', path ? path[0][0] : '');
					page.goto_list_page(path ? path[0][0].join('/') : (self._package || ''));
					self.update_category_links();
					self.scroll_to_col2();
				})
			);

			o.el.find('h2:contains(Filters)').length || o.el.section('.filters').h2('Filters');
			w.filters = o.el.find('.filters')

			facet_filter.events.bind('changed', function() {
				if(self._package && facet_filter._active){
					localStorage[self._package] = JSON.stringify({facet_selection: $.map(facet_filter._active, function(v, i) {
							return i + ',' + v.join(',');
						}).join(';')
					});
				}
			});
		},

		col2: function(o) {
			var self = this, w = this.widgets;

			if(!this.centered){
				// main-column-wrapper is a scrollwindow for listing and product columns
				// -it is needed for horizontal control but is a big problem vertically because
				// its height needs to be continually adjusted.
				$('.main-column-wrapper').length || w.col2.add(w.col3).appendTo($(ECMWF.options.dom.content_parent || '#main').div('.main-column-wrapper'));
			}

			o.el.addClass(overlay ? 'overlay' : 'no-overlay');

			o.el.parent().div('.column col2-control').prependTo(o.el.parent())
				.h2('Results').parent()
				.a().div().text('show product results').click(function() {
					w.col2.panel('show');
					return false;
				});

			if(false)
			(this.login_box = o.el.div('.login-message')).messages({messageBus: self.login_box.messageBus(), enable_popup: true, message_class: 'col-2-message'});

			list.selection.always = false;
			list.set_collection(products);

			var filters = [/*TypeFilter,*/ text_filter, facet_filter];
			this.config.enable_hierarchy && filters.push(path_filter);
			$.map(filters, function(f) {
				if($.isFunction(f.fn)){
					f.init && f.init();
					list.filters.push(f);
				}
			})

			if(!__VGRID__){
				w.grid = o.el
					.find('.panel-content')
					.grid({
						text_filter_parent: w.col1.find('.text-filter-row').orelse(function(){ return w.filters.div('.text-filter-row').hide(); }),
						on_click: self._bind(self._on_thumbnail_click),
						size_fits_content: true,
						on_model_change: function(items){
							w.package_select && products.packages.then(w.package_select.init);
						},
						on_view_change: function() {
							self.do_layout();
						},
						on_view_ready: function() {
							config.show_view_buttons && w.grid.find('.head').show(); // buttons hidden until width stabilizes.
							if(list.items.length > 20) w.col1.find('.text-filter-row').show();
							self.do_layout();
						}
					})
					.each(function() {
						var grid = $(this);
						grid.find('.foot').prependTo(grid);
					});
			}else{
				// new grid widget using the 'simple' view option

				P(w.col1.find('.text-filter-row')
					.orelse(function(){ return w.filters.div('.text-filter-row'); }))
					.filter_input(list.lookup_filter_by_name('text'));

				var vgrid = new VGrid({
					view_mode: 'simple',
					element: o.el, // temporary - element to trigger render on
					// TODO check is called
					on_click: self._bind(self._on_thumbnail_click),
					// TODO not-implemented
					on_model_change: function(items){
						w.package_select && products.packages.then(w.package_select.init);
					},
					// TODO not-implemented
					on_view_change: function() {
						self.do_layout();
					},
					// TODO not-implemented
					on_view_ready: function() {
						config.show_view_buttons && w.grid.find('.head').show(); // buttons hidden until width stabilizes.
						if(list.items.length > 20) w.col1.find('.text-filter-row').show();
						self.do_layout();
					}
				})
				self.vdom = {
					root: o.el.find('.panel-content')[0],
					tree: virtualise(o.el.find('.panel-content')[0]) // get a virtualNode object
				}
				var render = $.throttle(250, function() {
					var new_tree = h('.panel-content', [vgrid.render()])
					self.vdom.root = patch(self.vdom.root, diff(self.vdom.tree, new_tree));
					self.vdom.tree = new_tree;
				})

				o.el.on('render', function() {
					render();
				});
				list.subscribe(self, self._on_filter = function() {
					render();
				})
				if(list.filtered) self._on_filter();

				w.grid = o.el.find('.panel-content')
			}

			list.subscribe(function(){
				if(w.facets && list.lookup_filter_by_name('facets')){
					if(!facet_filter.status()) w.facets.facets('clear');
					w.facets.facets('on_filter_change'); // the facets widgets doesnt know about the filter list so the change handler is triggered manually
				}

				w.package_select && w.package_select.on_filter_change();

				// filter changes have no impact on history state unless the view is changed from product to listing.
				n_filter_runs && self.col2.css.left && page.add_state();

				self.on_filter_change();

				var n_products = $.where(products.products, {filter_pass: true}).length;

				if(overlay){
					setTimeout(function() {
						w.col2.panel('show');
						self.widgets.grid.grid('resize'); // TODO panel should send event
					}, 1000);
				}else{
					n_filter_runs && self.col2.css.left && page.goto_list_page(products.query.package);
					self.do_layout();

					// TODO layout sometimes happens before grid-items height is being set.
					setTimeout(function(){ self.do_layout(); }, 1000);
				}

				n_filter_runs++;
			});

			list.on.items.subscribe(function() {
				console.log('%cpackage change:', 'background-color:#ff9', products.query.package);
				packages.get(self._package).then(function(pkg){
					$.each(page_handlers, function(i, v) {
						if(i === 'epsgram'){
							v.remove()
						}
					})

					products.sorted_facets(pkg, ['Product group'], function(fc) {
						w.facets = w.filters.find('.facets').orelse(function() { return w.filters.div(); }).facets({
							products: products,
							facets: fc,
							selection: (function() {
								var r = {};

								var pkg = products.query.package;
								var facet = localStorage[pkg]
									? JSON.parse(localStorage[pkg]).facet_selection
									: null;
								if (page._path.q){
									var args = qs.parse(page._path.q.slice(1));
									if (args.facets){
										facet = args.facets;
									}
								}
								// example url query: ?facets=Product group,Basic EFI;Component,Atmosphere,Geography
								if(facet){
									var facets = facet.split(';');
									$.each(facets, function(i, v) {
										var f = v.split(',');
										if(f.length > 1){
											r[f.shift()] = $.map(f, function(v, i) { return $.trim(v); });
										}
									});
								}
								return r;
							})(),
							on_change: function(a, b, val) {
								facet_filter.set([a, b], val);
							}
						});
					})
				})

				// navigation
				products.packages.then(function(packages) {
					var p = $.findWhere(packages, {name: products.query.package});
					if(p){
						w.links = (p.links && p.links.length)
							? $('#block-menu-block-2').empty().orelse(function(){ return self.widgets.col1.section('#block-menu-block-2').addClass('links').prependTo(self.widgets.col1) }).show().ul('.menu')
								.each(function() {
									var w = $(this)
									$.each(p.links, function(i, link) {
										w.li('.menu__item is-leaf leaf')
											.a({href: link.url, className: 'menu__link'}).text(link.title);
									});
								})
							: $('#block-menu-block-2').hide();
					}
				});
			});

			CH.product_change.subscribe(function() {
			});

			/*
			list.selection.subscribe(function()	{
				// -as much as we would like, this cannot be the main handler because we do not get clicks on an already-selected product.
			});
			*/

			if(!overlay){
				o.el.show();

				this.col2.css = {left: 0, width: 400, height: 400};
				this.col3.css = {};

				if(__VGRID__) delete this.col2.css.height;
			}

			this._package && packages.get(this._package).then(function(pkg){
				setTimeout(function(){
				if(pkg && pkg.additional_links && pkg.additional_links.length){
					var div = w.col2.find('> .additional-links').orelse(function(){
						var div = w.col2.div('.additional-links')
						div.h3('Additional charts');
						div.ul();
						return div;
					});
					var ul = div.find('> ul');
					$.each(pkg.additional_links, function(i, v) {
						var external = v.url.indexOf(page.base_path) !== 0;
						var a = ul.li().a({href: v.url.replace('@BACKEND', '//' + ECMWF.options.backend_host), rel: external ? 'external' : ''});
						a.img({src: v.thumbnail.replace('@BACKEND', '//' + ECMWF.options.backend_host)});
						a.div('.title').text(v.title);
					});
				}
				}, 1000)
			});
		},

		col3: function(o) {
			var self = this;
			var panel = this.col3;
			panel.widgets = {results: {}};

			if(!overlay){
				o.el.show();
				this.col3.size = {width: 400, height: 400};

				if(__VGRID__) delete this.col3.css.height;
			}

			this.size_override_targets = $('.top-bar #main').orelse(function(){ return $('#centred, #top, #footer > div'); }); // www vs apps

			Bus()
				.listen('chart-added', function() {
					CH.widgets.chart.messageBus().listen('chart-product-availability', function(_, msg) {
						if(msg.valid_time.values.length > 1){
							self.do_layout();
						}
					});
				})
				// TODO there is a better way than forwarding global to local bus?
				.listen('prev-step', function() {
					(CH.current === CH.interactive) && CH.current.bus.send('prev-step');
				})
				.listen('next-step', function() {
					(CH.current === CH.interactive) && CH.current.bus.send('next-step');
				/*
				})
				.listen('tool-animation-toggle', function() {
					(CH.current === CH.interactive) && CH.current.bus.send('tool-animation-toggle');
				*/
				});

			$('body').on('layout', function() {
				self._on_resize();
			});

			this.widgets.legend = o.el.div('#chart-legends').hide();
			this.widgets.content = o.el.div('.product-text text-content');

			this.have_chart.done(function() {
				var results = panel.widgets.results;

				(results.button = chart_handlers.widgets.controls.rhs
					.div('.results-button keep')
						.button({label: 'Filter results', icons: {secondary: 'ui-icon-triangle-1-s'}}))
						.prependTo(chart_handlers.widgets.controls.rhs)
						.click(function() {
							self.widgets.col3.find('.ui-menu').not(results.menu || null).hide();

							results.menu = results.menu
								? results.menu.toggle()
								: results.button.ul('.results-menu')
									.menu({
										/*
										select: function(event, ui){
											console.log('selection: ', ui.item.text(), ui.item.attr('data-value'));
											o.on_click(event, ui, o.name);
											self.select(ui.item);

											setTimeout(function() {
												var data = ui.item.parent().data('uiMenu');
												data && (data.mouseHandled = false); // jquery ui menu workaround
											}, 5);
										}
										*/
									})
									.each(function() {
										$(this).div().grid({
											collection: products,
											view_mode: 'details',
											text_filter_parent: $(),
											size_fits_content: true,
											enable_status: false,
											on_click: self._bind(self._on_thumbnail_click)
										})
										.find('.scrollable').perfectScrollbar({suppressScrollX: true, wheelSpeed: ECMWF.wheelspeed});

										$(this).find('.outer').div('.mask'); // prevents us having to set the detail item width
									});
							return false;
						});

				chart_handlers.widgets.controls.rhs
					.div('.back-button keep')
						.button({label: 'Back to chart listing', icons: {primary: 'ui-icon-arrowthick-1-w'}, text: false})
						.prependTo(chart_handlers.widgets.controls.rhs)
						.click(function() {
							page.add_state().goto_list_page(page._path.dir);
						});

				$('body').unbind('click', close).click(close);

				function close() {
					results.menu && results.menu.hide();
				}
			});

			/*
			chart_handlers.on.size_change = function(size) {
				overlay || self.do_layout();
			}
			*/

			/*
			this.widgets.next = o.el.div('.button-next').click(function() {
				self.widgets.grid.grid('next');
			});
			*/
		},

		on_filter_change: function() {
		},

		_on_thumbnail_click: function(item) {
			if((!page._path.page) || item !== CH.state.list_product){
				page.add_state();

				if(item === CH.state.list_product){
					// the selected product is the same as the previous product
					page.set_product(item.name(), item.title_());
				}else{
					// In this case, the page status is updated via the chart_handler.
					// This is wrong but fixing it requires the chart controls to be decoupled from the chart widget.

					var chart;
					if((chart = CH.widgets.chart && CH.widgets.chart.data('ui-basicChart'))){
						chart.grey();
					}
					this.on_product_select(item);
				}

				overlay && this.options.el.find('.ui-icon-close').click();
			}
		},

		scroll_to_col2: function() {
			if(!overlay){
				this.col2.css.left = 0;
				this.col3.css.left = this.col2.css.width;

				this.widgets.col2.css(this.col2.css);
				this.widgets.col3.css(this.col3.css);
			}
		},

		scroll_to_col3: function() {
			if(!overlay){
				this.col2.css.left = -this.col2.css.width;
				this.col3.css.left = 0;

				this.widgets.col2.css(this.col2.css);
				this.widgets.col3.css(this.col3.css);

				setTimeout(function() {
					if($(document).scrollTop() > 500){
						$(document).scrollTop($('h1').offset().top - 10)
					}
				}, 1000)
			}
		},

		q_size: function() {
			var width = Math.max(512, Math.min(1536, Math.floor(this.widgets.col3.width() / ECMWF.chart.q_width) * ECMWF.chart.q_width));
			return {
				width: width,
				height: width * 0.667
			}
		},

		on_product_select: function(product, params) {
			var self = this;

			App.prototype.on_product_select.apply(this, arguments);

			this.scroll_to_col3();

			if(CH.state.list_product === product) return;
			CH.set_state({list_product: product});

			this.widgets.col3.panel('set_title', product.title_ ? product.title_() : product.title());

			var is_interactive = !!~$.inArray('interactive', product.data.widgets);
			var chart_type = is_interactive ? 'interactive' : 'basic';

			var handler = chart_handlers[chart_type];
			handler.host = this;
			if(handler !== chart_handlers.current){
				var size = self.q_size();

				// 'current' is now set earlier to ensure that it is always set before listeners run.
				// (different require implements have varying amounts of asynchronicity)
				var old_handler = chart_handlers.current;
				chart_handlers.current = handler;

				old_handler && old_handler.cleanup();
				handler.build(product, params || (old_handler && old_handler.state), {el: this.widgets.col3, size: size}, function() {
					CH.widgets.chart.messageBus()
						.listen('size-changed', function(_, size) {
							self._on_resize(size);
						})
						.listen('chart-content-update', function(_, msg) {
							overlay || self.do_layout();
						})
						.listen('chart-legend-loaded', function() {
							self.do_layout();
						});

					$('body').unbind('layout.viewer').bind('layout.viewer', function() {
						if(is_interactive){
							var size = self.q_size();
							if(size.width !== CH.widgets.chart.width()){
								CH.widgets.chart.css(size);
								CH.widgets.chart.resize();
							}
							// update for height. TODO this negates the point of the check above.
							CH.widgets.chart.css(size);
							CH.widgets.chart.resize();
							overlay || self.do_layout();
						}
					});

					$.each(['legend', 'content', 'next'], function(i, v) {
						self.widgets[v] && self.widgets[v].appendTo(self.widgets.col3);
					});

					// update page-level handlers for different chart types
					// TODO don't remove unless is no longer relevant
					$.each(page_handlers, function(i, v) {
						v.remove && v.remove()
					});
					page_handlers = {};
					$.each(product.data.widgets, function(i, v) {
						if(!!~$.inArray(v, ['epsgram'])){
							page_handlers[v] = require('../handlers/epsgram')
						}
					})
				});
			}else{
				handler.update(product);
			}
		},

		do_layout: window.is_node ? $.noop : $.debounce(200, function() {
			var self = this, col2 = self.widgets.col2, col3 = self.widgets.col3, column_padding = 50;

			(this.widgets.time_navigator && this.widgets.time_navigator.length) || (this.widgets.time_navigator = $('#time-navigator, .time-nav'));
			this.widgets.time_navigator.triggerHandler('layout', {width: this.widgets.time_navigator.width()});

			if(!overlay){
				var col1_width = this._col1_width();
				var left_width = col1_width + (col1_width ? column_padding : 0);
				var scrollbar_width = window.innerWidth - $(window).width()

				var normal_width = this.config.use_column_width
					? $(window).width() - col1_width - 2 * self.config.page.borderx - column_padding
					: 0; // ignore the column width, just use the chart width
				var is_interactive = !!~$.inArray('interactive', CH.state.list_product && CH.state.list_product.data.widgets);
				var q_size = is_interactive ? self.q_size() : {};
				self.col3.size.width = q_size.width || Math.max(normal_width, (CH.widgets.chart && CH.widgets.chart.find('img').width()) || 480);
				self.col2.css.width = $(window).width() - col1_width - 2 * self.config.page.borderx - column_padding;
				self.col2.css.width = Math.max(self.col2.css.width, self.col3.size.width); // it prevents having to relayout the page if col2 is the same width as col3

				var max_width = parseInt(this.widgets.grid.find('.grid-items').css('max-width'), 10);
				if(max_width){
					self.col2.css.width = max_width;
					self.col2.css.paddingRight = 32;
				}

				// TODO there is content below at small screen width due to column wrapping (unless is moved to a menu).
				self.col2.css.height = (col2.find('.catalogue-grid').outerHeight(true) || 1024) + col2.find('.additional-links').outerHeight(true) + 120;

				var w = self.col2.css.width;
				$('#main').css({width: self.col2.css.width + left_width - 0});
				$('#wrap').css({width: self.col2.css.width + left_width + 2 * self.config.page.borderx}).attr({sizor: 'viewer.layout'});

				self.col3.size.height = (chart_handlers.widgets.chart ? chart_handlers.widgets.chart.height() : 0) + $('#chart-legends').height() + col3.find('> .block').outerHeight(true) + $('.product-text').height() + 300;
				$('.main-column-wrapper').css({
					width: self.is_landing_page ? undefined : w, // if size is not exactly the same as the natural size, it causes nasty judder, so dont set unless neccesary.
					height: Math.max(self.col2.css.height, self.col3.size.height)}).attr({sizor: 'viewer.layout'
				});
if(!__VGRID__){
				col2.css(self.col2.css).attr({sizor: 'viewer.layout'});
				col3.css(self.col3.size).attr({sizor: 'viewer.layout'});
}
				if(self.col2.css.left) self.scroll_to_col3(); else self.scroll_to_col2();
				self.widgets.grid
					//.css({height: self.col2.css.height}) // grid height currently set in css
					.triggerHandler('layout');

				$.each(page_handlers, function(i, v) {
					v.layout && v.layout();
				});
			}
		}),

		on_url_change: function(ctx) {
			var self = this;

			App.prototype.on_url_change.apply(this, arguments);

			if(self.is_landing_page){
				list.have_items.then(function(items) {
					self.h1(products.hierarchy.lookup(page._path.dir).title);
				});
			}else{
				self.have_chart.done(function() {
					self.h1(CH.state.list_product.long_title());
				});
			}
		},

		update_category_links: function() {
			var self = this;

			this.config.enable_hierarchy && products.fetch(function(items) {
				var children = products.hierarchy.children(page.params.product_path);
				self.widgets.path_links.empty();
				for(var c in children){
					var child = children[c];
					self.widgets.path_links.li().a({href: child.name + '/'}).text(child.title).click(function() {
						console.log('category.click: child=', $(this).attr('href'));
						path_filter.set_child($(this).attr('href').replace('/', ''));
						return false;
					});
				}
				self.widgets.category_h2.text(ECMWF.ucfirst(page.params.product_path[page.params.product_path.length - 1].replace(/-/g, ' ')));

				self.widgets.path_links.add(self.widgets.category_h2)[(!children) || $.isEmptyObject(children) ? 'hide' : 'show']();
			});
		}
	});
});
