/*
 *  TODO
 */
define(['jquery', 'ajax_queue', 'filterable-list', 'virtual-dom/h', 'grid/products', 'chart_app/router'], function($, Ajaxqueue, list, h, Products, page){

var show_title = true;
var img_data = {}

var VGridSimpleView = function(options){
	this.create(options)
}

// note: currently does not inherit from ViewBase
VGridSimpleView.prototype = {

	create: function(options) {
		this.options = $.extend({
			select: $.noop,
			scrollbar: null
		}, options);

		var self = this, o = this.options;

		this.eventNamespace = 'vgrid6'; // TODO

		this.item_options = {
			on_click: function(item) {
				var selected = o.element.find('.selected');
				var widget = o.element.find('[name="' + item.name() + '"]').parents('.item');
				if(!widget.hasClass('selected')){
					self.select(item);
					o.select(item);
				}
				o.click(item);
			},
			on_dblclick: function(item) {
				o.dblclick(item);
			}
		},

		show_title && (this.item_options.show_title = true);

		this.options.element.on('click', function(ev) {
			console.log('simple.click');
			var target = $(ev.target);

			var item = Products.product_by_name(target.attr('name') || target.find('img.thumbnail-img').attr('name'));
			self.item_options.on_click(item);
		});

		this.options.scrollbar.state.height = 0;
	},

	/*
	_destroy: function() {
		list.unsubscribe(this);
	},
	*/

	render: function() {
		var self = this, o = self.options;
		//console.log('%csimple.render', 'background-color:#ff9')

		Products.cancel_thumbnails();

		this.groups_valid || this._update_groups();

		items = [];
		var group_label_height = (self.groups.length > 1) ? self.group_label_height : 0;

		self._results_by_group(
			function(group){
				if(self.groups.length > 1){
					items.push(h('h3', {
						style: {clear: 'both'},
						onclick: function(e){
							page.add_state();
							facets = list.lookup_filter_by_name('facets')
							facets.set(['Product group', group.name], true)
							e.stopPropagation()
						}
					},
					[group.name]));
				}
			},
			function(item, m, d, ig, gr){
				var local = item[self.eventNamespace];

				var column = ig % self.n_columns;

				var url = img_data[item.name()] || item.cache.thumbnail.call(item); // cannot use the normal thumbnail method here because it is asynchronous

				items.push(h('div.item.thumbnail-wrapper' + (local && local.selected ? '.selected' : ''), {style: {position: 'static', float: 'left'}}, [
					h('div.thumbnail', [
						h('img.thumbnail-img', {
							alt  : item.title_(),
							title: $('<div>').html(item.data.description).text() || item.title_(),
							name : item.name(),
							src  : (url && (url !== 'validation failed')) ? url : ECMWF.blank_gif,
							style: url
								? { visibility: 'visible', opacity: 1.0 }
								: { visibility: 'hidden', opacity: 0.0 },
							onclick: function() {
							}
						})
					]),
					h('div' + (show_title ? '.title' : '.hidden') + (item.has_widget('clickable') ? '.clickable' : ''), item.title_())
				]));

				!url && item.thumbnail && item.thumbnail({tag: item.name() + self.eventNamespace}, function(url, image, error){
					if(!error){
						if(image){
							// we may have multiple callbacks from the same request, so img_data may already be set
							img_data[item.name()] = image;
						}
						self.options.on_needs_render();
					}
				});
			}
		);

		return h('div.grid-items.thumbs.simple', {
			style: {height: '400px'},
			click: function(){
					console.log('groups.click');
					var target = $(ev.target);

					var item = Products.product_by_name(target.attr('name') || target.find('img.thumbnail-img').attr('name'));
					self.item_options.on_click(item);
			}
		}, items);
	},

	select: function(item) {
		var self = this;

		list.have_filtering.done(function() {
			if(!item[self.eventNamespace]) item[self.eventNamespace] = {}; // do this earlier?
			var local = item[self.eventNamespace];
			self._each_allocated(function(item, m, d){
				if(item[self.eventNamespace]) delete item[self.eventNamespace].selected;
			});
			local.selected = true;
			self.options.on_needs_render();
		});
	},

	_update_groups: function() {
		var self = this, group;

		self.groups = [];
		for(var i=0;i<list.filtered.length;i++){
			var item = list.items[list.filtered[i]];
			var g = ((item.data.tags || [])['Product group'] || [])[0] || 'Other';
			if(g !== group){
				self.groups.push({name: group = g, i: i});
			}
		}
		//console.log('* _update_groups: groups=', self.groups.length, self.groups);

		this.groups_valid = true;
		self._positions_valid = false;
		return self.groups.length > 1;
	},

	_each_allocated: function(fn) {
		var self = this, o = self.options;

		for(var i=0;i<list.filtered.length;i++){
			var m = list.filtered[i];
			var item = list.items[list.filtered[i]];
			//var local = item[self.eventNamespace];
			//if(!local.visible) console.log('each_allocated: range ', self._first, i, ' (' + (i - self._first) + ')');

			fn(item, m, i);
		}
	},

	// only results in viewport
	_results_by_group: function(fn1, fn2) {
		var self = this;

		var g = -1, gr = {};
		this._each_allocated(function(item, m, d){
			//var local = item[self.eventNamespace];
			var ig = 0;//local.ig;
			var group_name = ((item.data.tags && item.data.tags['Product group'] || [])[0]) || 'Other';
			if(g < 0 || (group_name && group_name !== gr.name)){
				g++;
				gr = $.findWhere(self.groups, {name: group_name});
				fn1(gr);
			}
			fn2(item, m, d, ig++, gr, g);
		});
	},

	_results_by_group_all: function(fn1, fn2, done) {
		var self = this;
		var g = -1, ig = 0, gr = {};
		for(var i=0;i<list.filtered.length;i++){
			var item = list.items[list.filtered[i]];
			var group_name = ((item.data.tags && item.data.tags['Product group'] || [])[0]) || 'Other';
			if(!i || (group_name !== gr.name)){
				g++;
				gr = $.findWhere(self.groups, {name: group_name});
				fn1(gr);
				ig = 0;
			}
			fn2(item, i, ig++, gr, g);
		};
		done && done(gr);
	},

	resize: function() {
		/*
		var self = this, o = self.options;

//		if(!self.element.is(':visible') && !o.grid.options.size_fits_content) return;
		self._old_n_visible_items = self.cache.n_cells;
		var old_n_columns = self.n_columns;

		self.n_columns = Math.floor(o.width / (self.item_width + self.padding.x));
		if(__DEV__ && !self.n_columns) self.n_columns = 5, console.warn('failed to calculate number of columns');
		//self.cache.n_cells = self.n_columns * (Math.round(container_size.height / (self.item_height + self.padding.y)) + settings.overscan);
		self.cache.n_cells = 6 // TODO is it being used?

		if((self.n_columns !== old_n_columns) || (self.cache.n_cells !== self._old_n_visible_items)){
			//console.log('thumbs._resize: need re-layout: height=' + container_size.height + ' n_visible=' + self.cache.n_cells);
//			self.__post_resize_assignment();
			list.have_filtering.done(function(){
				self._assign_fresh();
//				self._set_scrollbar_size();
			});
		}
		*/
	},
}

return VGridSimpleView;

});
