console.warn("www_parameter_menu NO LONGER IN USE");

define(['jquery', 'bus', 'basic_chart/parameter_controls/menu'], function($, Bus){

	$.widget('ui.wwwChartParameterBar', {
		options: {
			variables      : null,
			bus            : Bus(),
			click_handlers : {}
		},

		_create: function(){
			var self = this, o = this.options;

			var ui_version = $.ui.version.split('.');
			require((ui_version[0] < 2 && ui_version[1] < 9) ? ['jquery_menu'] : [], function(){

				var bar = self.element.addClass('rhs-toolbar www-chart-parameter-bar');

				var blacklist = ['step'];
				for(var i in o.variables){
					var v = o.variables[i];
					if(/^(?:retention|choice|location)$/.test(v.type) && !~jQuery.inArray(v.name, blacklist)){
						bar.div().wwwChartParameter($.extend({bus: o.bus}, v, {on_click: o.click_handlers[v.name] || o.click_handlers.default_handler}));
					}
				}

				self._apply_ellipsis();
			});
		},

		add: function(parameter){
			var self = this, o = this.options;

			self.element.div().wwwChartParameter($.extend({bus: o.bus}, parameter, {on_click: o.click_handlers[parameter.name] || o.click_handlers.default_handler}));
		},

		setItems: function(parameter){
			this.element.find('.parameter-selector:contains(' + parameter.title + ')').wwwChartParameter('setItems', parameter);
		},

		onSizeChange: function(){
			this._apply_ellipsis();
		},

		closeAll: function(){
			this.element.find('.ui-menu').hide();
		},

		_apply_ellipsis: function(){
			var self = this, o = this.options;

			var padding = {l: 14, r: 23}
			var n_chars = 0; $.each(o.variables, function(i, v){ n_chars += v.title.length; });
			var width = Math.max(1, self.element.parent().width() - 32 - (padding.l + padding.r + 1) * o.variables.length);
			var density = n_chars / width;
			//console.log('apply_ellipsis: n_chars=', n_chars, ' width=', self.element.parent().width(), width, 'density=', (Math.round(density * 100) / 100), 'chars/pixel');
			self.element.find('> .parameter-selector').each(function(){
				if(density > 0.12)
					$(this).css({maxWidth: width / o.variables.length + padding.l + padding.r}).find('span').addClass('ellipsis');
				else
					$(this).css({maxWidth: 'none'}).find('span').removeClass('ellipsis');
			});
		}
	});
});
